#!/usr/bin/env node

global = window = {Babel: { }}; //LEG

const Babel = global.Babel = require('babel-standalone'),
fs = require('fs-extra'),
path = require('path'),
chillout = require('chillout-es7'),
klaw = require('klaw'),
util = require('util'),
debug = util.debuglog('bin'),
ENV = process.env,
ARG = Array.from(process.argv).slice(2);

try {
	require('babel-polyfill');
	require('babili-standalone');
} catch(ign) { }

if (!ARG.length) {
	console.info('\tbs[ from=./[ to=from]]');
	process.exit();
}

process.once('beforeExit', () => {
	console.log('Completed.');
});

var from = path.normalize(ENV.from || ARG[0] || './'),
type = fs.statSync(from).isDirectory(),
to = path.normalize(ENV.to || ARG[1] || from);

async function walk(src = './') {
	return new Promise((rsl, rjc) => {
		var k = klaw(path.normalize(src));
		k.gathered = [ ];
		k.on('data', chunk => {
			if (chunk) {
				if (chunk.path.endsWith('.js') && chunk.stats.isFile()) {
					k.gathered.push(chunk);
				}
			}
		});
		k.once('end', () => rsl(k.gathered));
	});
} //walk

function compile(code = '') {
	try {
		return Babel.transform(code, {
			presets: [ENV.preset || 'es2015']
		}).code;
	} catch(err) {
		console.error(err);
		return code;
	}
} //compile

if (type) {
	fs.ensureDirSync(to);
	walk(from).then(files => {
		debug(files);
		chillout.forEach(files, file => {
			var out = path.normalize(to + path.sep + path.relative(from, file.path));
			debug(out);
			fs.readFile(file.path, (err, data) => {
				if (!err) {
					fs.outputFile(out, compile(data));
				}
			});
		});
	});
} else {
	fs.ensureFileSync(to);
	fs.writeFileSync(to, compile(fs.readFileSync(from)));
}
